=== debian/changelog ===
corsix-th (0.62-2) unstable; urgency=medium

  * fix FTBFS since ImageMagick 6.9.10-16 (Closes: 919083)
  * use normal team Maintainer address for DDPO
  * bump Standards-Version, no changes needed
  * bump debhelper-compat to 12

 -- Phil Morrell <debian@emorrp1.name>  Thu, 31 Jan 2019 21:04:00 +0000

corsix-th (0.62-1) unstable; urgency=medium

  [ Phil Morrell ]
  * add gbp.conf
  * add contrib disclaimer
  * lintian testsuite fix, bump metadata
  * allow more variety in signature files
  * fix dh_auto_test nocheck indentation #902392
  * add more verbose flags for S-V 4.2
  * remove obsolete packaging
  * convert manpage to markdown, build with pandoc

  [ Sebastian Ramacher ]
  * New upstream version 0.62
  * debian/: Make cmake install files in correct location.
  * debian/copyright: Update copyright info
  * debian/control:
    - Recommend timidity. (Closes: #904838)
    - Update ffmpeg Build-Depends according to build system.

 -- Phil Morrell <debian@emorrp1.name>  Mon, 13 Aug 2018 14:59:23 +0100
