=== debian/watch ===
version=4

opts="pgpmode=next,uversionmangle=s/-/~/" \
 https://github.com/CorsixTH/CorsixTH/releases \
 (?:.*/)?v?@ANY_VERSION@@ARCHIVE_EXT@

opts="pgpmode=previous,uversionmangle=s/-/~/" \
 https://github.com/CorsixTH/CorsixTH/releases \
 (?:.*/)?(?:CorsixTH)?v?@ANY_VERSION@@SIGNATURE_EXT@ \
 previous
