=== CorsixTH/CMakeLists.txt ===
--- 
+++ 
@@ -78,6 +78,11 @@
   set_target_properties(CorsixTH PROPERTIES OUTPUT_NAME corsix-th)
 endif()
 
+# Set language standard
+set_property(TARGET CorsixTH PROPERTY CXX_STANDARD 11)
+set_property(TARGET CorsixTH PROPERTY CXX_EXTENSIONS OFF)
+set_property(TARGET CorsixTH PROPERTY CXX_STANDARD_REQUIRED ON)
+
 # Add an extra step to copy built DLLs on MSVC
 if(USE_VCPKG_DEPS)
   include(CopyVcpkgLua)
@@ -244,6 +249,13 @@
   )
   install(FILES CorsixTH.lua ../LICENSE.txt DESTINATION ${CORSIX_TH_DATADIR})
 
+  if(UNIX AND NOT APPLE)
+    install(FILES corsix-th.6 DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)
+    install(FILES com.corsixth.CorsixTH.appdata.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
+    install(FILES com.corsixth.CorsixTH.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
+    install(FILES Original_Logo.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps RENAME corsix-th.svg)
+  endif()
+
   if(APPLE)
     # Fix the OS X bundle to include required libraries (create a redistributable app)
     install(CODE "
