=== debian/changelog ===
corsix-th (0.63-2) unstable; urgency=medium

  * Team upload
  * Add patch to build successfully against recent SDL2 packaging
    (Closes: #953002)

 -- Simon McVittie <smcv@debian.org>  Sun, 29 Mar 2020 11:58:01 +0100

corsix-th (0.63-1) unstable; urgency=low

  * Team upload.

  [ Alexandre Detiste ]
  * New upstream version 0.63
  * fix GPG part of uscan watch file
  * refresh default config patch
  * upstream now provides a man page, use it

  [ Stephen Kitt ]
  * Use the upstream-installed desktop file, appdata and icon.

 -- Stephen Kitt <skitt@debian.org>  Sun, 17 Nov 2019 21:29:49 +0100
