=== debian/control ===
--- 
+++ 
@@ -19,7 +19,6 @@
  libswscale-dev (>= 7:2.8),
  lua-busted,
  lua5.2,
- pandoc,
 Standards-Version: 4.3.0
 Homepage: http://corsixth.com
 Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
