=== debian/watch ===
--- 
+++ 
@@ -6,5 +6,5 @@
 
 opts="pgpmode=previous,uversionmangle=s/-/~/" \
  https://github.com/CorsixTH/CorsixTH/releases \
- (?:.*/)?(?:CorsixTH)?v?@ANY_VERSION@@SIGNATURE_EXT@ \
+ (?:.*/)?(?:CorsixTH)?v?@ANY_VERSION@/CorsixTH@SIGNATURE_EXT@ \
  previous
