=== debian/changelog ===
corsix-th (0.64-2) unstable; urgency=medium

  * switch to upstream git history
  * use debhelper-compat 13 for automatic nocheck profile
  * allow reprotest to fail (gcc_captures_build_path)
  * fix national-encoding traditional_chinese.lua.
    Thanks to yangfl
  * lintian fixes and version bumps

 -- Phil Morrell <debian@emorrp1.name>  Mon, 07 Dec 2020 22:02:29 +0000

corsix-th (0.64-1) unstable; urgency=medium

  * New upstream version 0.64
  * fix GPG watch file (again)
  * refresh FindSDL2 patch

 -- Phil Morrell <debian@emorrp1.name>  Sun, 09 Aug 2020 04:55:20 +0100
