=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Phil Morrell <debian@emorrp1.name>,
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  imagemagick,
  libavcodec-dev (>= 7:2.8),
  libavformat-dev (>= 7:2.8),
@@ -19,7 +19,7 @@
  libswscale-dev (>= 7:2.8),
  lua-busted,
  lua5.2,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.1
 Homepage: http://corsixth.com
 Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
 Vcs-Browser: https://salsa.debian.org/games-team/corsix-th
